/*
 * sht4x.c
 *
 *  Created on: Jun 8, 2021
 *      Author: user
 */

#include "sht4x.h"
#include "main.h" /* for uart_disable_interrupts() */

int8_t sht4x_send_cmd(sht4x_cmd_t cmd)
{
	return SHT4X_OK;
}

int8_t sht4x_read_data(uint8_t *buffer, int len)
{
	return SHT4X_OK;
}

int8_t sht4x_measure(int16_t *temperature, uint16_t *relative_humidity)
{
	uint8_t buffer[32];
	int result;

	// start measurement
	buffer[0] = SHT4X_START_MEAS_HIGH_PRECISION;
	result = i2c_transmit(SHT4X_I2C_ADDRESS<<1, buffer, 1);
	// TODO: Proc to vraci NACK? Vyresit.
	/*
	if (result != I2C_OK) {
		return SHT4X_ERROR;
	}*/
	/*uart_disable_interrupts();
	LL_mDelay(10); // 10 ms should be enough
	uart_enable_interrupts();
	*/
	HAL_Delay(10);
	// read out
	result = i2c_receive(SHT4X_I2C_ADDRESS<<1, buffer, 6);
	if (result != I2C_OK) {
		return SHT4X_ERROR;
	}
	// TODO checksum
	// Convert to T and RH; taken directly from pseudocode in SHT4x datasheet, page 3
	uint32_t t_ticks = (buffer[0] << 8) + buffer[1];
	uint32_t rh_ticks = (buffer[3] << 8) + buffer[4];
	int t_degC = -450 + 10 * 175 * t_ticks / 65535; /* temperature * 10 */
	int rh_pRH = -6 + 125 * rh_ticks / 65535;
	if (rh_pRH > 100) {
			rh_pRH = 100;
	}
	if (rh_pRH < 0) {
		rh_pRH = 0;
	}
	*temperature = t_degC;
	*relative_humidity = rh_pRH;

	return SHT4X_OK;
}
